"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var fs = require('fs');

var convertor = require('xml-js');

var Generator = /*#__PURE__*/function () {
  function Generator(baseUrl, baseComponent) {
    _classCallCheck(this, Generator);

    _defineProperty(this, "_paths", []);

    this._baseUrl = baseUrl;
    this._baseComponent = baseComponent;
  }

  _createClass(Generator, [{
    key: "_generate",
    value: function _generate() {
      this._paths = [];
      var components = [];
      components.push(this._baseComponent());

      while (components.length !== 0) {
        var component = components.pop();
        var props = component.props;

        if (props != null) {
          var nestedComponent = props.children,
              path = props.path,
              propsComponents = props.component;

          if (path != null) {
            this._paths.push(path);
          }

          components.push.apply(components, _toConsumableArray(this._getComponents(nestedComponent)));
          components.push.apply(components, _toConsumableArray(this._getComponents(propsComponents === null || propsComponents === void 0 ? void 0 : propsComponents({
            match: {
              url: path
            }
          }))));
        }
      }
    }
  }, {
    key: "_getComponents",
    value: function _getComponents(components) {
      var _components = [];

      if (Array.isArray(components)) {
        components === null || components === void 0 ? void 0 : components.forEach(function (child) {
          _components.push(child);
        });
      } else if (components != null) {
        _components.push(components);
      }

      return _components;
    }
  }, {
    key: "getXML",
    value: function getXML() {
      var _this = this;

      this._generate();

      var options = {
        compact: true,
        spaces: 4
      };
      var map = {
        _declaration: {
          _attributes: {
            version: '1.0',
            encoding: 'UTF-8'
          }
        },
        urlset: {
          url: this._paths.map(function (path) {
            return {
              loc: _this._baseUrl + path,
              lastmod: '2021-01-01',
              changefreq: 'monthly',
              priority: 0.8
            };
          }),
          _attributes: {
            xmlns: 'http://www.sitemaps.org/schemas/sitemap/0.9'
          }
        }
      };
      return convertor.js2xml(map, options);
    }
  }, {
    key: "save",
    value: function save(path) {
      var xml = this.getXML();
      fs.writeFileSync(path, xml);
    }
  }]);

  return Generator;
}();

exports["default"] = Generator;